\ignore{
\begin{code}
{- This work was originally done by Pierre-Étienne Meunier, and is now placed in
the public domain, to the extent permitted by applicable law.  Use at your own
risk.  -}
import Math.SelfAssembly.Manhattan
import qualified Data.Map as M
import Numeric
\end{code}
}
\begin{code}
programme::Int->Program ()
programme n=do
  seed 7 0
  movey 3
  a<-currentTile
  movey n
  a1<-currentTile
  movex (-2)
  movey 3
  b<-currentTile
  movey 1
  c<-currentTile
  movey (n-1)
  b1<-currentTile
  movex (-5)
  gr<-currentTile
  movey 2
  gr1<-currentTile
  movey 1
  gr2<-currentTile
  movey (n-1)
  movex 1
  movey (-n-1)
  bot<-currentTile
  movex 2
  bind N a

  rewindTo a1
  movex 1
  movey 1
  movex (-1)
  bind N gr1

  rewindTo bot
  rewindBy 1
  movex 1
  bind N c
  rewindTo b1
  movey 1
  movex (-1)
  bind N gr2
\end{code}
\ignore{
\begin{code}
showf (x,y)="("++showFFloat (Just 4) x (","++showFFloat (Just 4) y ")")

main::IO ()
main=do
  putStrLn "n Tileset_size Manhattan_distance"
  let n=3
      (seeds,tiles)=execProgram $ programme n
      seeds1=(2,3*n+8,-1):(8,n+3,-1):(2,2*n+8,-1):(5,2*n+7,-1):seeds
      seeds2=(7,1,-1):seeds1
      seeds3=(0,2*n+10,-1):seeds1
      --seeds1=seeds
  (x0,y0,x1,y1,grid) <- simulate 20 (2*M.size tiles) seeds1 [] tiles
  tikzPlot "eff0.tex" (defaultPlot {fontSize=6,showGlues=True,offset=2,scale=0.2}) tiles grid;

  (x0,y0,x1,y1,grid) <- simulate 20 (2*M.size tiles) seeds2 [] tiles
  tikzPlot "eff1.tex" (defaultPlot {fontSize=6,showGlues=True,offset=2,scale=0.2}) tiles grid;

  (x0,y0,x1,y1,grid) <- simulate 20 (2*M.size tiles) seeds3 [] tiles
  tikzPlot "eff2.tex" (defaultPlot {fontSize=6,showGlues=True,offset=2,scale=0.2}) tiles grid;

  (x0,y0,x1,y1,grid) <- simulate 20 (2*M.size tiles) seeds [] tiles
  tikzPlot "eff3.tex" (defaultPlot {fontSize=6,showGlues=True,offset=2,scale=0.2}) tiles grid;

  let n=10
      (seeds,tiles)=execProgram $ programme n
  (x0,y0,x1,y1,grid) <- simulate 20 (2*M.size tiles) seeds [] tiles
  tikzPlot "eff4.tex" (defaultPlot {fontSize=6,showGlues=True,offset=2,scale=0.2}) tiles grid;

  putStrLn $ "Tileset size: "++(show $ M.size tiles)
  putStrLn $ "Maximum Manhattan distance: "++show (x0,y0)++" to "++show (x1,y1)
  putStrLn $ "("++show ((abs $ x1-x0)+(abs $ y1-y0))++")"
\end{code}
}