\ignore{
\begin{code}
{- This work was originally done by Pierre-Étienne Meunier, and is now placed in
the public domain, to the extent permitted by applicable law.  Use at your own
risk.  -}
import Math.SelfAssembly.Manhattan
import qualified Data.Map as M
import Numeric
\end{code}
}
\begin{code}
programme::Int->Int->Program ()
programme n h=do
  seed (3^n+n) 0
  -- A first occurrence of the construction creates the cave.
  movey 2
  a<-currentTile
  movey (h-2)
  c<-currentTile
  movex (-3^(n-1)-n)
  -- Start of the cave
  b<-currentTile
  movey h
  movex 1 -- Top of the cave
  movey (-h+1)
  d<-currentTile -- Bottom of the cave
  -- Now, move to the right, and repeat tile a
  movex (2*3^(n-2))
  bind N a
  -- Now, iterate n times. To avoid making the path pumpable, we need to reduce
  -- the height (paremeter hh) each time.
  let prog n hh b0 d0=
        if n<=0 then
          return ()
        else do
          movey 1
          an<-currentTile
          movey (hh)
          cn<-currentTile
          movex (-3^(n)+n)
          bind N b0
          rewindTo d0
          movex (2*3^(n-1)-n)
          bind N an
          b1<-nextTile b0
          d1<-prevTile d0
          rewindTo cn
          prog (n-1) (hh-1) b1 d1
  -- Go back to tile c, and start iterating.
  rewindTo c
  b0<-nextTile b
  b1<-nextTile b0
  d0<-prevTile d
  prog (n-2) (h-3) b1 d0
\end{code}
\ignore{
\begin{code}
showf (x,y)="("++showFFloat (Just 4) x (","++showFFloat (Just 4) y ")")

main::IO ()
main=do
  putStrLn "n Tileset_size Manhattan_distance"
  let n=3
      (seeds,tiles)=execProgram $ programme 8 10
  (x0,y0,x1,y1,grid) <- simulate 10000 10000 seeds [] tiles
  plot "general.pdf"
    (defaultPlot {fontSize=0.20,showGlues=True,showPaths=False,offset=0.5,scale=10,font="Latin Modern Roman"}) tiles grid;


  putStrLn $ "Tileset size: "++(show $ M.size tiles)
  putStrLn $ "Maximum Manhattan distance: "++show (x0,y0)++" to "++show (x1,y1)
  putStrLn $ "("++show ((abs $ x1-x0)+(abs $ y1-y0))++")"
\end{code}
}
