\ignore{
\begin{code}
{- This work was originally done by Pierre-Étienne Meunier, and is now placed in
the public domain, to the extent permitted by applicable law.  Use at your own
risk.  -}
import Math.SelfAssembly.Manhattan
import qualified Data.Map as M
--import Prelude hiding (repeat)
--repeat=repete
\end{code}
}
\begin{code}
programme::Program ()
programme=do
  seed 0 0
  movey 1
  a0<-currentTile
  -- First step: grow the part that will be repeated.
  --
  -- Since we want to grow upwards, and then follow it downwards closely,
  -- we need precise control over its shape.
  repete 15
    (do
        repete 20 (do { movey 2;movex 1 })
        movex 1)
  a<-nextTile a0
  -- Now, lay a "blocker" out, for the partially pumped paths to stop.
  movex 1
  movey (-1)
  movex (-2)
  -- Then go down.
  repete 15
    (do
        repete 20 (do { movey (-2);movex (-1) })
        movex (-1))
  -- Now, build the bottom of the construction.
  rewindBy 6
  c<-currentTile
  eraseAfter c
  movey (-1)

  let x2=40
      tot=21*15-1-x2
      x0=15
      x1=(tot-x0)`quot`3-15

  -- Record the three different starting tiles of exit paths.
  movex x0
  start0<-currentTile
  movex x1
  start1<-currentTile
  movex (tot-x1-x0)
  start2<-currentTile
  -- Now, from each starting tile, grow a partially pumpable path, that will be
  -- blocked on its way up.

  -- First exit path.
  rewindTo start2
  pump (do
           setColor blue
           discreteVect 16 (16*15-3))

  -- Here, the transition to the next repetition is simple: we just move to the
  -- right by 120 columns, lay a blocker out, so that the repeated part (from
  -- tile a) cannot be repeated completely.
  rewindBy 3
  movex 120
  movey 2
  movex (-1)
  movey (-1)
  movex (-x1-x0-5)
  bind N a -- Finally, start the repeated part again.


  -- The second exit path is more complicated, since we do not want it to
  -- collide with the first pumped path. Moreover, the discreteVect function is
  -- used to build the most efficient vector (in terms of number of tile types)
  -- with the given coordinates.
  rewindTo start1
  pump
    (do
        setColor red
        let distx=tot-x0-x1+x2+1
            disty=15*40
        discreteVect (distx`quot`2) (disty`quot`2))
  rewindBy 51
  movex 10
  repete 7
    (do
        repete 20 (do { movey 2;movex 1 })
        movex 1)

  movex (x0+4)
  movey 2
  movex (-1)
  movey (-1)
  movex (-x0-4)
  bind N a

  -- The "final" exit path is similar, but simpler: we closely follow the
  -- repeated part.
  rewindTo start0
  movey 1
  movex 1
  pump
    (do
        setColor green
        repete (149) (do { movey 2; movex 1 }))

  movex 2
  repete 2
    (do
        repete (148) (do { movey 2; movex 1 })
        movex 2)

  movex 10
  movey 2
  movex (-1)
  movey (-1)
  movex (-2)
  bind N a

\end{code}
\ignore{
\begin{code}
main::IO ()
main=do
  l<-mapM (\it->do
              let (seeds,tiles)=execProgram programme
              print seeds
              (x0,y0,x1,y1,grid)<-simulate 2000 5000 seeds [] tiles
              plot "programme.pdf" (defaultPlot { showGlues=True,offset=10}) tiles grid;
              putStrLn $ "Tileset size: "++(show $ M.size tiles)
              let x=x1-x0
                  y=y1-y0
              putStrLn $ "Maximum Manhattan distance: "++(show $ abs x+abs y)++" "++(show (x,y))
              return (it,abs x+abs y, M.size tiles)
          ) [3]

  writeFile "graph" $ unlines $ map (\(it,a,b)->show it++" "++show a++" "++show b) l
\end{code}
}